<template>
  <div class="ui middle center aligned grid">
    <div class="container">
      <h2 class="ui blue image header">
        <img
          src="/static/img/logo.png"
          class="image"
        >
        <div class="content">
          Connectez-vous à votre compte
        </div>
      </h2>

      <form class="ui large form" @submit.prevent="login">
        <div class="ui stacked segment">
          <div class="field">
            <div class="ui left icon input">
              <i class="user icon"></i>
              <input
                type="text"
                name="login"
                placeholder="Identifiant"
                v-model="username"
                required
              >
            </div>
          </div>
          <div class="field">
            <div class="ui left icon input">
              <i class="lock icon"></i>
              <input
                type="password"
                name="password"
                placeholder="Mot de passe"
                v-model="password"
                required
              >
            </div>
          </div>
          <button
            class="ui fluid large blue submit button"
            type="submit"
            :class="loading ? 'loading disabled' : ''"
          >
            Se connecter
          </button>
        </div>
      </form>
    </div>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'

import store from '@/store/Store'

export default {
  name: 'Login',
  store,
  data () {
    return {
      username: '',
      password: ''
    }
  },
  beforeCreate () {
    if (store.isAuthenticated) {
      this.$router.push({ name: 'home' })
    }
  },
  methods: {
    login () {
      const { username, password } = this
      this.$store.dispatch('AuthStore/login', { username, password }).then(
        (authUser) => {
          this.$toastr.s('Bienvenue ' + (authUser.firstname && authUser.lastname ? authUser.firstname + ' ' + authUser.lastname : authUser.username))
          this.$router.push({ name: 'home' })
        },
        (error) => {
          this.$toastr.e(error.code === 522 ? 'Identifiant invalide' : 'Erreur de connexion')
        })
    }
  },
  computed: {
    ...mapGetters({
      authUser: 'AuthStore/authUser',
      loading: 'loading'
    })
  }
}
</script>
